unit KochOPCMAin;

interface
uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls,
  System.Threading, Vcl.ExtCtrls
  , OpcLabs_EasyOpcUA_TLB
  , OpcLabs_EasyOpcForms_TLB
  , OpcLabs_BaseLib_TLB ;

type

  TClientConfigurationEventHandlers130 = class
    // Handler for exposing all the OPC failures , for Certificates etc, deep in OPC System
    procedure OnLogEntry(ASender: TObject; sender: OleVariant; const eventArgs: _LogEntryEventArgs);
  end;

  TFormKochOPCmain = class(TForm)
    Button_Connect: TButton;
    Memo1: TMemo;
    procedure Button_ConnectClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
     function OpenOPCcomms: Boolean;
  public
    { Public declarations }
  end;

var
  Endpoint                           : String;   // Actual Address IP:Port of PLC
  FormKochOPCmain                    : TFormKochOPCmain;
  Client                             : TEasyUAClient;    //ORIGINAL MARCH
  ClientConfiguration                : OpcLabs_EasyOpcUA_TLB.TEasyUAClientManagement;
  ClientConfigurationEventHandlers   : TClientConfigurationEventHandlers130;
implementation

{$R *.dfm}

procedure TFormKochOPCmain.Button_ConnectClick(Sender: TObject);
begin
  if OpenOPCcomms then
   Showmessage('Success....')
  Else
   Showmessage('Failed....') ;
end;

procedure TFormKochOPCmain.FormCreate(Sender: TObject);
begin
//   if OpenOPCcomms then
//   Showmessage('Success....')
//  Else
//   Showmessage('Failed....') ;
end;

procedure TFormKochOPCmain.FormDestroy(Sender: TObject);
begin
  // Clean up Event logging handlers started in on Form Create
  FreeAndNil(ClientConfiguration);
  FreeAndNil(ClientConfigurationEventHandlers);
end;

function TFormKochOPCmain.OpenOPCcomms: Boolean;
var
  EndPoint : String;
begin
      EndPoint := 'opc.tcp://192.168.17.250:4840'; //Location of OPC server and portnumber
      Memo1.lines.add('Creating OPC Event Handler '+ EndPoint);
      ClientConfiguration               := OpcLabs_EasyOpcUA_TLB.TEasyUAClientManagement.Create(nil);
      Memo1.lines.add('TClientConfigurationEventHandlers130.Create '+ EndPoint);
      ClientConfigurationEventHandlers  := TClientConfigurationEventHandlers130.Create;
      Memo1.lines.add('ClientConfigurationEventHandlers.OnLogEntry; '+ EndPoint);
      ClientConfiguration.OnLogEntry    := ClientConfigurationEventHandlers.OnLogEntry;
      Memo1.lines.add('ClientConfiguration.Connect; '+ EndPoint);
     Try
      Showmessage('About to Execute Connect call in ClientConfiguration');
      ClientConfiguration.Connect;  {<<<<<<  Crash in OPCLabs software .NETT}

      Memo1.lines.add('OPC Event Handler Connected '+ EndPoint);
      // Ok Lets create our Client OPC inteface class
      Memo1.lines.add('Creating OPC Client '+ EndPoint);
      Client   := OpcLabs_EasyOpcUA_TLB.TEasyUAClient.Create(nil);
      Memo1.lines.add('OPC Client Created'+ EndPoint);
      Result := true;
     Except
      Showmessage('Failed to connect to finish ClientConfiguration.Connect ');
      Result := False;
     End;
end;

{ TClientConfigurationEventHandlers130 }

procedure TClientConfigurationEventHandlers130.OnLogEntry(ASender: TObject;
  sender: OleVariant; const eventArgs: _LogEntryEventArgs);
var
  myFile : TextFile;
begin
  AssignFile(myFile, 'Colin_Logs.txt');
  if fileexists('Colin_Logs.txt') then
    append(myFile)
  Else
    ReWrite(myFile);

  WriteLn(myFile, eventArgs.ToString);
  CloseFile(myFile);
end;

end. {THE END}
